﻿package{
	
	import flash.display.Sprite;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.events.MouseEvent;
	/*import flash.geom.*
    import flash.display.*
	/*

	
	/*HORLOGE A FORMES GEOMETRIQUES*/
	/*INTRODUCTION DE LA NOTION DE DATE*/
	/*INTRODUCTION DE LA GESTION DES COULEURS EN HEXADECIMAL*/
	
	public class Clock extends Sprite{
		
		private var myTimer:Timer;
		private var now:Date;
		private var hourcolor:String;
		private var minutecolor:String;
		private var secondcolor:String;
		//private var bg:BitmapData;
		//private var container:Bitmap;
		
		public function Clock():void{
			
			//bg = new BitmapData(stage.stageWidth,stage.stageHeight,false,0xFFFFFF);
			//container = new Bitmap(bg);
			//addChild(container);
			/*on établi des couleurs de référence*/
			chargeColor(null);
			/*on lance l'horloge*/
			startTimer();
			/*on ajoute la fonction de changement de couleurs au click*/
			stage.addEventListener(MouseEvent.CLICK,chargeColor);
			}
			
		private function startTimer():void{
			/*setup du timer toutes les secondes (1000 millisecondes)*/
			myTimer= new Timer( 1000, 0 );
			myTimer.addEventListener( TimerEvent.TIMER, updatehour );
			myTimer.start(); 
		}
		
		private function updatehour(Tevt:TimerEvent ){
			/*on efface tous les vecteurs de l'écran*/
			if(Tevt.currentTarget.currentCount !=1){
				while(numChildren>0) removeChildAt(0);
				};
			/*on récupère l'heure actuelle, heure, minutes, secondes*/
			now = new Date(); 
			var heure:String = reglage( now.hours );
			var minute:String = reglage( now.minutes );
			var seconde:String = reglage( now.seconds );
			
			/*on construit les formes suivant l'heure, on positionne sur l'écran, on affecte les couleurs*/
			//shapeBuilder(Number(heure.substring(0,1)),150,100,hourcolor);
			shapeBuilder1(Number(heure.substring(0,2)),mouseX,mouseY,hourcolor);
			
			//shapeBuilder(Number(minute.substring(0,1)),170,300,minutecolor);
			shapeBuilder2(Number(minute.substring(0,2)),mouseX,mouseY,minutecolor);
			
			//shapeBuilder(Number(seconde.substring(0,1)),250,450,secondcolor);
			shapeBuilder3(Number(seconde.substring(0,2)),mouseX,mouseY,secondcolor);
			}
		/*on rajoute un 0 pour les valeurs en dessous de 10*/
		private function reglage( valeur:uint ):String{
			return (valeur<10) ? "0"+valeur : String(valeur);
		}
		
		private function chargeColor(e:MouseEvent):void{
			hourcolor = buildColor();
			minutecolor = buildColor();
			secondcolor = buildColor();
			}
		/*construction d'une valeur STRING pour une couleur aléatoire*/
		private function buildColor():String{
			var R:uint = Math.round(Math.random()*255);
			var G:uint = Math.round(Math.random()*255);
			var B:uint = Math.round(Math.random()*255);
			var nbr:uint =  R << 16 | G << 8 | B;
			return "0x"+nbr.toString(16);
			}
		
		private function shapeBuilder1(nbr:uint,X:uint,Y:uint,color:String):void{
				var angle:Number;
				if(nbr == 0){
					angle = 1;
				}else if(nbr ==1){
					angle = 360/2;
				}else if(nbr !=0){
					angle = 360/nbr;
				}
				/*on définit une longueur de ligne aléatoire pour avoir un peu de mouvement	*/
				var longueur:uint = 70;
				//var longueur1:uint = Math.random()*30;
				
				var myShape:Sprite = new Sprite();
				//myShape.graphics.lineStyle(0,Number(color),1);
				myShape.graphics.beginFill(Number(color),1);
				myShape.graphics.moveTo(longueur,0);
				/*on dessine les forme d'après des principe de trigonométrie*/
				
				 for(var i:uint=0;i<360;i+=angle){
					 var posx:Number = Math.cos(Math.PI*i/60)*longueur;
					 var posy:Number = Math.sin(Math.PI*i/60)*longueur;
					 if(i!=0){
						 myShape.graphics.lineTo(posx,posy);
						 }
					 }
				myShape.graphics.lineTo(longueur,0);
				myShape.x=X;
				myShape.y=Y;
				/*petit tricks pour le 1 qui n'a pas de valeur d'angle*/
				if(nbr == 1){
					myShape.rotation = 180;
					}
				/*on ajoute la forme à l'écran*/
				addChild(myShape);
			//}
			}
			
			
			
			
	 private function shapeBuilder2(nbr:uint,X:uint,Y:uint,color:String):void{
				var angle:Number;
				if(nbr == 0){
					angle = 1;
				}else if(nbr ==1){
					angle = 360/6;
				}else if(nbr !=0){
					angle = 360/nbr;
				}
				/*on définit une longueur de ligne aléatoire pour avoir un peu de mouvement	*/
				var longueur:uint = 50;
				//var longueur1:uint = Math.random()*30;
				
				var myShape:Sprite = new Sprite();
				//myShape.graphics.lineStyle(0,Number(color),.8);
				myShape.graphics.beginFill(Number(color),1);
				myShape.graphics.moveTo(longueur,0);
				/*on dessine les forme d'après des principe de trigonométrie*/
				
				 for(var i:uint=0;i<360;i+=angle){
					 var posx:Number = Math.cos(Math.PI*i/20)*longueur;
					 var posy:Number = Math.sin(Math.PI*i/20)*longueur;
					 if(i!=0){
						 myShape.graphics.lineTo(posx,posy);
						 }
					 }
				myShape.graphics.lineTo(longueur,0);
				myShape.x=X;
				myShape.y=Y;
				/*petit tricks pour le 1 qui n'a pas de valeur d'angle*/
				if(nbr == 1){
					myShape.rotation = 60;
					}
				/*on ajoute la forme à l'écran*/
				addChild(myShape);
			//}
			}
			
			private function shapeBuilder3(nbr:uint,X:uint,Y:uint,color:String):void{
				var angle:Number;
				if(nbr == 0){
					angle = 1;
				}else if(nbr ==1){
					angle = 360/10;
				}else if(nbr !=0){
					angle = 360/nbr;
				}
				/*on définit une longueur de ligne aléatoire pour avoir un peu de mouvement	*/
				var longueur:uint = 30;
				//var longueur1:uint = Math.random()*30;
				
				var myShape:Sprite = new Sprite();
				
				//myShape.graphics.lineStyle(0,Number(color),.8);
				/*var fillType:String = GradientType.LINEAR;
 				var colors:Array = [Number(color), Number(color)];
  				var alphas:Array = [1, 1];
				var ratios:Array = [0x00, 0xFF];
  				var matr:Matrix = new Matrix();
  				matr.createGradientBox(20, 20, 0, 0, 0);
  				var spreadMethod:String = SpreadMethod.PAD;
  				myShape.graphics.beginGradientFill(fillType, colors, alphas, ratios, matr, spreadMethod);
				*/


				myShape.graphics.beginFill(Number(color),1);
				myShape.graphics.moveTo(longueur,0);
				/*on dessine les forme d'après des principe de trigonométrie*/
				
				 for(var i:uint=0;i<360;i+=angle){
					 var posx:Number = Math.cos(Math.PI*i/20)*longueur;
					 var posy:Number = Math.sin(Math.PI*i/20)*longueur;
					 if(i!=0){
						 myShape.graphics.lineTo(posx,posy);
						 }
					 }
				myShape.graphics.lineTo(longueur,0);
				myShape.x=X;
				myShape.y=Y;
				/*petit tricks pour le 1 qui n'a pas de valeur d'angle*/
				if(nbr == 1){
					myShape.rotation = 36;
					}
				/*on ajoute la forme à l'écran*/
				addChild(myShape);
			//}
			}
		}
	}